= How do I add a new Tomcat instance? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

Tomcat is installed in `<%= node['tomcat']['install_dir'] %>` (`CATALINA_HOME`). 
The working instance has an HTTP connector listening on port 8080 (local only, since the firewall blocks that port
by default), and an AJP connector listening on port 8009 (also local only).

If you would like another Tomcat working copy (e.g., to deploy your application as the root context), you can add an
instance that listens on different ports. You do not need to copy the Tomcat application itself.

To add a new Tomcat instance, e.g., in `/var/lib/tomcat7_2`:
{{{
#!application/x-sh
newTomcat=/var/lib/tomcat7_2
sudo mkdir -p $newTomcat/work $newTomcat/webapps $newTomcat/logs $newTomcat/temp 
sudo cp -R <%= node['tomcat']['install_dir'] %>/conf $newTomcat/
sudo chmod -R 0700 $newTomcat/conf $newTomcat/temp $newTomcat/work
sudo chmod -R 0750 $newTomcat/logs
sudo chmod -R 0770 $newTomcat/webapps
sudo chown -R tomcat:tomcat $newTomcat/logs $newTomcat/temp $newTomcat/work $newTomcat/webapps 
}}}

Edit `/var/lib/tomcat7_2/server.xml` to change the port numbers to unused ports:
 * shutdown (8005)
 * AJP connector (8009)
 * HTTP connector (8080)
 * HTTPS connector (8443)
 
Then, create startup and shutdown wrapper scripts.

startupTomcat2.sh:
{{{
#!application/x-sh
#! /bin/sh

export CATALINA_HOME=<%= node['tomcat']['install_dir'] %>
export CATALINA_BASE=/var/lib/tomcat7_2
export JAVA_HOME=<%= node['java']['java_home'] %>

$CATALINA_HOME/bin/startup.sh
}}}

shutdownTomcat2.sh:
{{{
#!application/x-sh
#! /bin/sh

export CATALINA_HOME=/usr/java/apache-tomcat-<%= node['tomcat']['version'] %>
export CATALINA_BASE=/var/lib/tomcat2
export JAVA_HOME=/usr/java/jdk<%= node['java']['install_flavor'] %>

$CATALINA_HOME/bin/shutdown.sh
}}}

Alternatively, you could modify and/or clone `/etc/init.d/tomcat` to configure the additional Tomcat instance to 
be automatically started when the system boots.

Don't forget to [../OpenPortInFirewall open the port in the firewall] for whichever port (or ports) you are
listening on. Otherwise, you'll only be able to access the ports locally (from the SecureCI™ system itself).

<%= node['trac']['wiki']['footer'] %>